package com.yingpaipay.setting.service.impl;

import com.yingpaipay.setting.domain.AgreementSetting;
import com.yingpaipay.setting.domain.bo.AgreementSettingBo;
import com.yingpaipay.setting.domain.vo.AgreementSettingVo;
import org.dromara.common.core.constant.CacheNames;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;
import com.yingpaipay.setting.mapper.AppletSettingMapper;
import com.yingpaipay.setting.service.IAgreementSettingService;

import java.nio.charset.StandardCharsets;
import java.util.Base64;
import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 小程序设置Service业务层处理
 *
 * @author Huanyi
 * @date 2025-11-28
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class AgreementSettingServiceImpl implements IAgreementSettingService {

    private final AppletSettingMapper baseMapper;

    /**
     * 查询小程序设置
     *
     * @param id 主键
     * @return 小程序设置
     */
    @Cacheable(cacheNames = CacheNames.SETTING, key = "'agreement'")
    @Override
    public AgreementSettingVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询小程序设置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 小程序设置分页列表
     */
    @Override
    public TableDataInfo<AgreementSettingVo> queryPageList(AgreementSettingBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<AgreementSetting> lqw = buildQueryWrapper(bo);
        Page<AgreementSettingVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的小程序设置列表
     *
     * @param bo 查询条件
     * @return 小程序设置列表
     */
    @Override
    public List<AgreementSettingVo> queryList(AgreementSettingBo bo) {
        LambdaQueryWrapper<AgreementSetting> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<AgreementSetting> buildQueryWrapper(AgreementSettingBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<AgreementSetting> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(AgreementSetting::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getUserAgreement()), AgreementSetting::getUserAgreement, bo.getUserAgreement());
        lqw.eq(StringUtils.isNotBlank(bo.getPrivacyAgreement()), AgreementSetting::getPrivacyAgreement, bo.getPrivacyAgreement());
        return lqw;
    }

    /**
     * 新增小程序设置
     *
     * @param bo 小程序设置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(AgreementSettingBo bo) {
        AgreementSetting add = MapstructUtils.convert(bo, AgreementSetting.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改小程序设置
     *
     * @param bo 小程序设置
     * @return 是否修改成功
     */
    @CachePut(cacheNames = CacheNames.SETTING, key = "'agreement'")
    @Override
    public Boolean updateByBo(AgreementSettingBo bo) {
        AgreementSetting update = MapstructUtils.convert(bo, AgreementSetting.class);
        if (StringUtils.isNotBlank(update.getUserAgreement())) {
            update.setUserAgreement(new String(Base64.getDecoder().decode(update.getUserAgreement()), StandardCharsets.UTF_8));
        }
        if (StringUtils.isNotBlank(update.getPrivacyAgreement())) {
            update.setPrivacyAgreement(new String(Base64.getDecoder().decode(update.getPrivacyAgreement()), StandardCharsets.UTF_8));
        }
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(AgreementSetting entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除小程序设置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

}
